/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var PageSelection = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsIVariant);
var PageURL = ""
var PageHost = "";
var PromptText = "";
var PromptPref = "";
var SelectedText = "";
var ConfigLastWillId = "";
var ConfigLastWillCtrl = false;
var act = "";


function FillMenu(){
try{
	FetchPrefs();
  var ppMenu = document.getElementById("cq-ppm");
	while (ppMenu.hasChildNodes()) {ppMenu.removeChild(ppMenu.lastChild)}
  var entries = EntryHash._Items();
  for (entry in entries){
	  if (entries[entry].Context){
		  var ppItem = document.createElement("menuitem");
		  ppItem.setAttribute("label", entries[entry].Title);
		  ppItem.setAttribute("tooltiptext", "Hold Ctrl to tune it up");
//		  if (entries[entry].haslist){
//		    ppItem.setAttribute("style", "font-style: italic");
//		    ppItem.setAttribute("tooltiptext", "Query has additionl values. Hold Ctrl to configure");
//		  }
		  //ppItem.setAttribute("onmouseover", "SelectedEnrtyId="+entries[entry].eId+";");
		  ppItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entries[entry].eId+"')");
		  ppMenu.appendChild(ppItem);
		}
  }
}catch(er){cqerr(er, "FillMenu sub")}
}

function ProcessEntry(ctrl, EntryId){
	getPageParams();
	entry = EntryHash._Item(EntryId);
	if (ctrl) ShowAlternatives = true;

	//if plugin not loaded - load it
	if (!entry.Inputs){
		entry = ReadPluginData(entry.filepath);
		entry.eId = EntryId;
		EntryHash._AddEntryObj(entry, entry.eId);
	}

  PrepareAction(entry.Inputs);
	if (cancel){
		resetenv();
		return;
	}
	if (entry.Method == "POST"){
		PassData(entry.Action);
		goUrl("chrome://conquery/content/post.xul");
	}else{
		goUrl(MakeURL(entry.Action+"?"));
	}
}

function PrepareAction(lcInputObj){
try{
  for (i in lcInputObj){
    switch(lcInputObj[i].def.value){
      case "[:selection]":
        if (!PageSelection) ShowAlternatives=true;
        QueryHash[lcInputObj[i].def.name] = PageSelection;
        break;
      case "[:url]":
        QueryHash[lcInputObj[i].def.name] = PageURL;
        break;
      case "[:host]":
        QueryHash[lcInputObj[i].def.name] = PageHost;
        break;
      case "[:prompt]":
        ShowAlternatives=true;
        QueryHash[lcInputObj[i].def.name] = "";
        break;
      default:
        QueryHash[lcInputObj[i].def.name] = lcInputObj[i].def.value;
    }
  }
  if (ShowAlternatives) window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", lcInputObj, NeedText);
}catch(er){cqerr(er, "PrepareAction sub")}
}

function MakeURL(prefix){
  amp = "";
  retval = prefix;
  for (each in QueryHash){
    retval += amp + each + "=" + QueryHash[each];
    amp = "&";
  }
  return retval;
}

function PassData(url){
// Ok! I gave up! If somebody knows the better way to pass data to new Tab, please e-mail me..
// Till then we will:
// - save data to mozprefs;
// - open new tab with post.xul
// - read it from there & erase.
try{
  Prefs.deleteBranch("temp.");
  Prefs.setCharPref("temp.action", url);
  for (each in QueryHash){
    Prefs.setCharPref("temp.Query."+each.replace(/\./, "/"), encodeURI(QueryHash[each]));
  }
}catch(er){cqerr(er, "PassData sub")}
}

function goUrl(uri) {
	resetenv();
  var browser = getBrowser();
	browser.selectedTab = browser.addTab(uri);
}

function OpenCfgDialog(){
	window.openDialog("chrome://conquery/content/conquery-pref.xul", "ConQuery config",	"centerscreen,chrome,modal,resizable=yes");
  if (ConfigLastWillId){
    ProcessEntry(ConfigLastWillCtrl, ConfigLastWillId);
  }
}

function getPageParams(){
	try{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		PageSelection = String(focusedWindow.__proto__.getSelection.call(focusedWindow));
	}catch(er){PageSelection=""}
  
  try{
  	PageURL = focusedWindow.location.href;
	}catch(er){PageURL=""}
	
	try{
	  	PageHost = focusedWindow.location.host;
	}catch(er){PageHost=""}
}

function resetenv(){
	QueryHash = new Object();
	PageSelection = "";
	PageURL = "";
	PageHost = "";
	PromptText = "";
	PromptPref = "";
	SelectedText = "";
	ConfigLastWillId = "";
	ConfigLastWillCtrl = false;
	act = "";
	ShowAlternatives = false;
	NeedText=false;
	cancel = false;
}